!
!	mod_matching.f90
!	ReplicationMS
!
!	Created by Oliver Will on 04.06.09.
!	Copyright 2009 Universität Bayreuth. All rights reserved.
!
MODULE MOD_MATCHING

	USE MOD_GLOBAL_VARIABLES
	USE MOD_AGENTSET
	USE MOD_OTHERS
	
	IMPLICIT NONE
	
	INTEGER, ALLOCATABLE, DIMENSION(:) :: Alter
	INTEGER, ALLOCATABLE, DIMENSION(:) :: Match
	
CONTAINS

	SUBROUTINE matching
		
		INTEGER :: i
		
		DO i = 1, number_of_agents
			Match(i) = i
			Alter(i) = TempAddress(i) * 1000 + i_random(1000)
		END DO
		
		CALL sort(1, number_of_agents)
		
		DO i = 1, number_of_agents
			Alter(i) = Match(i)
		END DO
		
		i = 1
		DO WHILE ( i <= number_of_agents )
			
			IF ( i == number_of_agents ) THEN
				EXIT
			END IF
			IF ( TempAddress(Alter(i)) == TempAddress(Alter(i+1)) ) THEN
				! the two are in the same location
				! agents are paired
				Match(i) = Alter(i+1)
				Match(i+1) = Alter(i)
				! we step to the next pair
				i = i + 2
			ELSE
				! matching is not possible thus agent remains unpaired and we step to the next
				Match(i) = 0
				i = i + 1
			END IF
			
		END DO
		
		CALL sort(1, number_of_agents)
		
		DO i = 1, number_of_agents
			IF ( Match(i) /= 0 ) THEN
				IF ( TempAddress(i) == TempAddress(Match(i)) ) THEN
					Partner(i) = Match(i)
				ELSE
					Partner(i) = 0
				END IF
			ELSE
				Partner(i) = 0
			END IF
		END DO
	
	END SUBROUTINE matching

	RECURSIVE SUBROUTINE sort(l, r)
	
		INTEGER, INTENT(IN) :: l
		INTEGER, INTENT(IN) :: r
		
		INTEGER :: i,j,z,x,y
		
		i=l
		j=r
		x=Alter((l+r)/2)
		
		DO
			DO WHILE ( Alter(i) < x)
				i = i + 1
			END DO
			
			DO WHILE ( x < Alter(j) )
				j = j - 1
			END DO
			
			IF ( i <= j ) THEN
				y = Alter(i) 
				Alter(i) = Alter(j)
				Alter(j) = y
				z = Match(i)
				Match(i) = Match(j)
				Match(j) = z
				i = i + 1
				j = j - 1
			END IF
			
			IF ( i > j ) THEN
				EXIT
			END IF
		END DO
		
		IF ( l < j ) THEN 
			CALL sort(l,j)
		END IF
		
		IF ( i < r ) THEN 
			CALL sort(i,r)
		END IF
		
	END SUBROUTINE sort
	
END MODULE
