!
!	mod_others.f90
!	ReplicationMS
!
!	Created by Oliver Will on 04.06.09.
!	Copyright 2009 Universität Bayreuth. All rights reserved.
!
MODULE MOD_OTHERS

	IMPLICIT NONE
	
CONTAINS

	! Function generates random number r, 0 <= r < upper_bound
	INTEGER FUNCTION i_random( upper_bound )
	
		IMPLICIT NONE
	
		INTEGER, INTENT(IN) :: upper_bound

		REAL :: rand_nr
	
		CALL random_number(rand_nr)
		i_random = INT( upper_bound * rand_nr )
	
	END FUNCTION i_random
	
	SUBROUTINE set_random_seed(new_seed)
	
		! declaration of parameter type
		INTEGER, INTENT(IN) :: new_seed
	
		INTEGER I
		INTEGER, ALLOCATABLE :: new (:), old(:)
	
		CALL RANDOM_SEED (SIZE = I)  ! I is set to the size of the seed array
		ALLOCATE (new(I))
		new = new_seed
		CALL RANDOM_SEED (PUT=new(1:I)) ! Sets seed from array new

	END SUBROUTINE set_random_seed

END MODULE
