!
!	mod_moving.f90
!	ReplicationMS
!
!	Created by Oliver Will on 04.06.09.
!	Copyright 2009 Universität Bayreuth. All rights reserved.
!

MODULE MOD_MOVING

	USE MOD_GLOBAL_VARIABLES
	USE MOD_AGENTSET
	USE MOD_OTHERS
	
	IMPLICIT NONE
	
CONTAINS

	! determines which agents change to another neighbourhood
	SUBROUTINE moving

		INTEGER :: i, newAddress
		REAL :: rand	
		
		DO i = 1, number_of_agents
		
			! did agent interact in a neighbourhood in last time-step
			IF ( TempAddress(i) > 0 ) THEN
				! agents that were newcomers and interacted in neighbourhood are no longer newcomers
				Newcomer(i) = 0
				Stranger(i) = 0
			END IF
			
			! check whether agent move
			CALL random_number(rand)
			IF ( rand < mobility_rate ) THEN
				! agent i moves to a random but different neighbourhood
				PermAddress(i)=MOD((PermAddress(i)+i_random(number_of_neighbourhoods - 1)), number_of_neighbourhoods ) + 1
				Newcomer(i) = 1
				Stranger(i) = 1
			END IF
		
		END DO
		
	END SUBROUTINE moving
	
	! determines which agents enter the market
	SUBROUTINE decide_on_market
	
		INTEGER i
		REAL :: rand
		
		DO i = 1, number_of_agents
			
			CALL random_number(rand)
			IF ( rand < PropMkt(i) ) THEN
				! agent i enters the market
				TempAddress(i) = 0
				Stranger(i) = 1
			ELSE
				! agent i stays in neighbourhood
				TempAddress(i) = PermAddress(i)
			END IF
		
		END DO
	
	END SUBROUTINE decide_on_market

END MODULE
