!
!	mod_statistics.f90
!	ReplicationMS
!
!	Created by Oliver Will on 05.06.09.
!	Copyright 2009 Universität Bayreuth. All rights reserved.
!
MODULE MOD_STATISTICS

	USE MOD_GLOBAL_VARIABLES
	USE MOD_AGENTSET
	
	! variables to store information of current time-step
	REAL :: CoopRate, CoopNeighbour, CoopNewcomer, CoopStranger
	REAL :: TrustRate, TrustNeighbour, TrustNewcomer, TrustStranger
	REAL :: ChkTTSRate, ChkTTSNeighbour, ChkTTSNewcomer, ChkTTSStranger
	REAL :: PayoffAll, PayoffNeighbour, PayoffNewcomer, PayoffStranger
	REAL :: MarketSize
	REAL :: meanPropCoop, meanPropMkt, meanPropChkTTS
	
	! variable to calculated informaation of average values over the last 1000 time-steps cumulated over all repetitions
	REAL :: avgCoopRate, avgCoopNeighbour, avgCoopNewcomer, avgCoopStranger
	REAL :: avgTrustRate, avgTrustNeighbour, avgTrustNewcomer, avgTrustStranger
	REAL :: avgChkTTSRate, avgChkTTSNeighbour, avgChkTTSNewcomer, avgChkTTSStranger
	REAL :: avgPayoffAll, avgPayoffNeighbour, avgPayoffNewcomer, avgPayoffStranger
	REAL :: avgMarketSize
	REAL :: avgMeanPropCoop, avgMeanPropMkt, avgMeanPropChkTTS
	
	! variable to calculated informaation of average values over the last 1000 time-steps
	REAL :: sr_avgCoopRate, sr_avgCoopNeighbour, sr_avgCoopNewcomer, sr_avgCoopStranger
	REAL :: sr_avgTrustRate, sr_avgTrustNeighbour, sr_avgTrustNewcomer, sr_avgTrustStranger
	REAL :: sr_avgChkTTSRate, sr_avgChkTTSNeighbour, sr_avgChkTTSNewcomer, sr_avgChkTTSStranger
	REAL :: sr_avgPayoffAll, sr_avgPayoffNeighbour, sr_avgPayoffNewcomer, sr_avgPayoffStranger
	REAL :: sr_avgMarketSize
	REAL :: sr_avgMeanPropCoop, sr_avgMeanPropMkt, sr_avgMeanPropChkTTS
	
	CHARACTER(LEN=80) :: sr_results_file = "sr_results.txt"
	CHARACTER(LEN=80) :: final_results_file = "finalresults.txt"
	
CONTAINS

	SUBROUTINE write_sr_results
		
		sr_avgCoopRate = sr_avgCoopRate / REAL(steps_to_record)
		sr_avgCoopNeighbour = sr_avgCoopNeighbour / REAL(steps_to_record)
		sr_avgCoopNewcomer = sr_avgCoopNewcomer / REAL(steps_to_record)
		sr_avgCoopStranger = sr_avgCoopStranger / REAL(steps_to_record)
		sr_avgTrustRate = sr_avgTrustRate / REAL(steps_to_record)
		sr_avgTrustNeighbour = sr_avgTrustNeighbour / REAL(steps_to_record)
		sr_avgTrustNewcomer = sr_avgTrustNewcomer / REAL(steps_to_record)
		sr_avgTrustStranger = sr_avgTrustStranger / REAL(steps_to_record)
		sr_avgChkTTSRate = sr_avgChkTTSRate / REAL(steps_to_record)
		sr_avgChkTTSNeighbour = sr_avgChkTTSNeighbour / REAL(steps_to_record)
		sr_avgChkTTSNewcomer = sr_avgChkTTSNewcomer / REAL(steps_to_record)
		sr_avgChkTTSStranger = sr_avgChkTTSStranger / REAL(steps_to_record)
		sr_avgMarketSize = sr_avgMarketSize / REAL(steps_to_record)
		sr_avgMeanPropCoop = sr_avgMeanPropCoop / REAL(steps_to_record)
		sr_avgMeanPropMkt = sr_avgMeanPropMkt / REAL(steps_to_record)
		sr_avgMeanPropChkTTS = sr_avgMeanPropChkTTS / REAL(steps_to_record)
		WRITE(4242,'(I3,F4.1,16(F6.3))') number_of_neighbourhoods, mobility_rate, sr_avgCoopRate, sr_avgCoopNeighbour, sr_avgCoopNewcomer, sr_avgCoopStranger, sr_avgTrustRate, sr_avgTrustNeighbour, sr_avgTrustNewcomer, sr_avgTrustStranger, sr_avgChkTTSRate, sr_avgChkTTSNeighbour, sr_avgChkTTSNewcomer, sr_avgChkTTSStranger, sr_avgMarketSize, sr_avgMeanPropCoop, sr_avgMeanPropMkt, sr_avgMeanPropChkTTS
	

		
	END SUBROUTINE write_sr_results
	
	SUBROUTINE write_final_results
	
	
		avgCoopRate = avgCoopRate / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgCoopNeighbour = avgCoopNeighbour / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgCoopNewcomer = avgCoopNewcomer / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgCoopStranger = avgCoopStranger / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgTrustRate = avgTrustRate / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgTrustNeighbour = avgTrustNeighbour / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgTrustNewcomer = avgTrustNewcomer / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgTrustStranger = avgTrustStranger / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgChkTTSRate = avgChkTTSRate / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgChkTTSNeighbour = avgChkTTSNeighbour / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgChkTTSNewcomer = avgChkTTSNewcomer / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgChkTTSStranger = avgChkTTSStranger / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgMarketSize = avgMarketSize / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgMeanPropCoop = avgMeanPropCoop / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgMeanPropMkt = avgMeanPropMkt / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		avgMeanPropChkTTS = avgMeanPropChkTTS / REAL(steps_to_record * UBOUND(random_seeds, DIM = 1))
		WRITE(42,'(I3,F4.1,16(F6.3))') number_of_neighbourhoods, mobility_rate, avgCoopRate, avgCoopNeighbour, avgCoopNewcomer, avgCoopStranger, avgTrustRate, avgTrustNeighbour, avgTrustNewcomer, avgTrustStranger, avgChkTTSRate, avgChkTTSNeighbour, avgChkTTSNewcomer, avgChkTTSStranger, avgMarketSize, avgMeanPropCoop, avgMeanPropMkt, avgMeanPropChkTTS
	
	
	END SUBROUTINE write_final_results
	
	SUBROUTINE statistics
	
		CALL calculate_cooperation_rates
		CALL calculate_trust_rates
		CALL calculate_ChkTTS_rates
		CALL calculate_mean_values_decision_vector
		CALL calculate_share_of_agents_on_markes
		
	END SUBROUTINE statistics
	
	SUBROUTINE calculate_cooperation_rates
	
		INTEGER :: i, count_agents_with_partner, count_neighbours, count_newcomer, count_strangers 
		
		count_agents_with_partner = 0
		count_neighbours = 0
		count_newcomer = 0
		count_strangers = 0
		CoopRate = 0
		CoopNeighbour = 0
		CoopNewcomer = 0
		CoopStranger = 0
		
		! count cooperating agents of different types and total number of agents of types
		DO i = 1, number_of_agents
			IF ( Partner(i) > 0 ) THEN
				count_agents_with_partner = count_agents_with_partner + 1
				CoopRate = CoopRate + Coop(i)
				IF (TempAddress(i) > 0 .AND. Newcomer(i) == 0) THEN
					! i is a neighbour
					count_neighbours = count_neighbours + 1
					CoopNeighbour = CoopNeighbour + Coop(i)
				END IF
				IF (TempAddress(i) > 0 .AND. Newcomer(i) == 1) THEN
					! i is a newcomer
					count_newcomer = count_newcomer + 1
					CoopNewcomer = CoopNewcomer + Coop(i)
				END IF
				IF (TempAddress(i) == 0) THEN
					! i is a stranger
					count_strangers = count_strangers + 1
					CoopStranger = CoopStranger + Coop(i)
				END IF
			END IF
		END DO
		
		! calculate mean values
		IF ( count_agents_with_partner > 0 ) THEN
			CoopRate = CoopRate / REAL(count_agents_with_partner)
		ELSE
			CoopRate = 0.0
		END IF
		IF ( count_neighbours > 0 ) THEN
			CoopNeighbour = CoopNeighbour / REAL(count_neighbours)
		ELSE
			CoopNeighbour = 0.0
		END IF
		IF ( count_newcomer > 0 ) THEN
			CoopNewcomer = CoopNewcomer / REAL(count_newcomer)
		ELSE
			CoopNewcomer = 0.0
		END IF
		IF ( count_strangers > 0 ) THEN
			CoopStranger = CoopStranger / REAL(count_strangers)
		ELSE
			CoopStranger = 0.0
		END IF
		
		! sum of values is tracked to calculate average over simulation
		avgCoopRate = avgCoopRate + CoopRate
		avgCoopNeighbour = avgCoopNeighbour + CoopNeighbour
		avgCoopNewcomer = avgCoopNewcomer + CoopNewcomer
		avgCoopStranger = avgCoopStranger + CoopStranger
		
		! sum of values is tracked to calculate average over one run of simulation
		sr_avgCoopRate = sr_avgCoopRate + CoopRate
		sr_avgCoopNeighbour = sr_avgCoopNeighbour + CoopNeighbour
		sr_avgCoopNewcomer = sr_avgCoopNewcomer + CoopNewcomer
		sr_avgCoopStranger = sr_avgCoopStranger + CoopStranger
		
	
	END SUBROUTINE calculate_cooperation_rates
	
	SUBROUTINE calculate_trust_rates
	
		INTEGER :: i, count_agents_with_partner, count_neighbours, count_newcomer, count_strangers 
		
		count_agents_with_partner = 0
		count_neighbours = 0
		count_newcomer = 0
		count_strangers = 0
		TrustRate = 0
		TrustNeighbour = 0
		TrustNewcomer = 0
		TrustStranger = 0
		
		! count trusting agents of different types and total number of agents of types
		DO i = 1, number_of_agents
			IF ( Partner(i) > 0 ) THEN
				count_agents_with_partner = count_agents_with_partner + 1
				TrustRate = TrustRate + Trusts(i)
				IF (TempAddress(i) > 0 .AND. Newcomer(i) == 0) THEN
					! i is a neighbour
					count_neighbours = count_neighbours + 1
					TrustNeighbour = TrustNeighbour + Trusts(i)
				END IF
				IF (TempAddress(i) > 0 .AND. Newcomer(i) == 1) THEN
					! i is a newcomer
					count_newcomer = count_newcomer + 1
					TrustNewcomer = TrustNewcomer + Trusts(i)
				END IF
				IF (TempAddress(i) == 0) THEN
					! i is a stranger
					count_strangers = count_strangers + 1
					TrustStranger = TrustStranger + Trusts(i)
				END IF
			END IF
		END DO
		
		! calculate mean values
		IF ( count_agents_with_partner > 0 ) THEN
			TrustRate = TrustRate / REAL(count_agents_with_partner)
		ELSE
			TrustRate = 0.0
		END IF
		IF ( count_neighbours > 0 ) THEN
			TrustNeighbour = TrustNeighbour / REAL(count_neighbours)
		ELSE
			TrustNeighbour = 0.0
		END IF
		IF ( count_newcomer > 0 ) THEN
			TrustNewcomer = TrustNewcomer / REAL(count_newcomer)
		ELSE
			TrustNewcomer = 0.0
		END IF
		IF ( count_strangers > 0 ) THEN
			TrustStranger = TrustStranger / REAL(count_strangers)
		ELSE
			TrustStranger = 0.0
		END IF
		
		! sum of values is tracked to calculate average over simulation
		avgTrustRate = avgTrustRate + TrustRate
		avgTrustNeighbour = avgTrustNeighbour + TrustNeighbour
		avgTrustNewcomer = avgTrustNewcomer + TrustNewcomer
		avgTrustStranger = avgTrustStranger + TrustStranger
		
		sr_avgTrustRate = sr_avgTrustRate + TrustRate
		sr_avgTrustNeighbour = sr_avgTrustNeighbour + TrustNeighbour
		sr_avgTrustNewcomer = sr_avgTrustNewcomer + TrustNewcomer
		sr_avgTrustStranger = sr_avgTrustStranger + TrustStranger
		
	END SUBROUTINE calculate_trust_rates

	SUBROUTINE calculate_ChkTTS_rates
	
		INTEGER :: i, count_agents_with_partner, count_neighbours, count_newcomer, count_strangers 
		
		count_agents_with_partner = 0
		count_neighbours = 0
		count_newcomer = 0
		count_strangers = 0
		ChkTTSRate = 0
		ChkTTSNeighbour = 0
		ChkTTSNewcomer = 0
		ChkTTSStranger = 0

		! count agents that check TTS of different types and total number of agents of types
		DO i = 1, number_of_agents
			IF ( Partner(i) > 0 ) THEN
				count_agents_with_partner = count_agents_with_partner + 1
				ChkTTSRate = ChkTTSRate + TTSChecked(i)
				IF (TempAddress(i) > 0 .AND. Newcomer(i) == 0) THEN
					! i is a neighbour
					count_neighbours = count_neighbours + 1
					ChkTTSNeighbour = ChkTTSNeighbour + TTSChecked(i)
				END IF
				IF (TempAddress(i) > 0 .AND. Newcomer(i) == 1) THEN
					! i is a newcomer
					count_newcomer = count_newcomer + 1
					ChkTTSNewcomer = ChkTTSNewcomer + TTSChecked(i)
				END IF
				IF (TempAddress(i) == 0) THEN
					! i is a stranger
					count_strangers = count_strangers + 1
					ChkTTSStranger = ChkTTSStranger + TTSChecked(i)
				END IF
			END IF
		END DO
		
		! calculate mean values
		IF ( count_agents_with_partner > 0 ) THEN
			ChkTTSRate = ChkTTSRate / REAL(count_agents_with_partner)
		ELSE
			ChkTTSRate = 0.0
		END IF
		IF ( count_neighbours > 0 ) THEN
			ChkTTSNeighbour = ChkTTSNeighbour / REAL(count_neighbours)
		ELSE
			ChkTTSNeighbour = 0.0
		END IF
		IF ( count_newcomer > 0 ) THEN
			ChkTTSNewcomer = ChkTTSNewcomer / REAL(count_newcomer)
		ELSE
			ChkTTSNewcomer = 0.0
		END IF
		IF ( count_strangers > 0 ) THEN
			ChkTTSStranger = ChkTTSStranger / REAL(count_strangers)
		ELSE
			ChkTTSStranger = 0.0
		END IF
		
		! sum of values is tracked to calculate average over simulation
		avgChkTTSRate = avgChkTTSRate + ChkTTSRate
		avgChkTTSNeighbour = avgChkTTSNeighbour + ChkTTSNeighbour
		avgChkTTSNewcomer = avgChkTTSNewcomer + ChkTTSNewcomer
		avgChkTTSStranger = avgChkTTSStranger + ChkTTSStranger
		
		sr_avgChkTTSRate = sr_avgChkTTSRate + ChkTTSRate
		sr_avgChkTTSNeighbour = sr_avgChkTTSNeighbour + ChkTTSNeighbour
		sr_avgChkTTSNewcomer = sr_avgChkTTSNewcomer + ChkTTSNewcomer
		sr_avgChkTTSStranger = sr_avgChkTTSStranger + ChkTTSStranger
	
	END SUBROUTINE calculate_ChkTTS_rates
	
	! is currently not implemented
	!SUBROUTINE calculate_payoff_statistics
	
	!END SUBROUTINE calculate_payoff_statistics
	
	SUBROUTINE calculate_mean_values_decision_vector
	
		meanPropCoop = SUM(PropCoop) / REAL(number_of_agents)
		meanPropMkt = SUM(PropMkt) / REAL(number_of_agents)
		meanPropChkTTS = SUM(PropChkTTS) / REAL(number_of_agents)
		
		avgMeanPropCoop = avgMeanPropCoop + meanPropCoop
		avgMeanPropMkt = avgMeanPropMkt + meanPropMkt
		avgMeanPropChkTTS = avgMeanPropChkTTS + meanPropChkTTS
		
		sr_avgMeanPropCoop = sr_avgMeanPropCoop + meanPropCoop
		sr_avgMeanPropMkt = sr_avgMeanPropMkt + meanPropMkt
		sr_avgMeanPropChkTTS = sr_avgMeanPropChkTTS + meanPropChkTTS
		
	END SUBROUTINE calculate_mean_values_decision_vector
	
	SUBROUTINE calculate_share_of_agents_on_markes
	
		MarketSize = COUNT(TempAddress == 0) / REAL(number_of_agents)
		avgMarketSize = avgMarketSize + MarketSize
		sr_avgMarketSize = sr_avgMarketSize + MarketSize
	
	END SUBROUTINE calculate_share_of_agents_on_markes
	

	SUBROUTINE reset_statistics
		avgCoopRate = 0
		avgCoopNeighbour = 0
		avgCoopNewcomer = 0
		avgCoopStranger = 0
		avgTrustRate = 0
		avgTrustNeighbour = 0
		avgTrustNewcomer = 0
		avgTrustStranger = 0
		avgChkTTSRate = 0
		avgChkTTSNeighbour = 0
		avgChkTTSNewcomer = 0
		avgChkTTSStranger = 0
		avgPayoffAll = 0
		avgPayoffNeighbour = 0
		avgPayoffNewcomer = 0
		avgPayoffStranger = 0
		avgMarketSize = 0
		avgMeanPropCoop = 0
		avgMeanPropMkt = 0
		avgMeanPropChkTTS = 0
	END SUBROUTINE reset_statistics
	
	SUBROUTINE reset_sr_statistics
		sr_avgCoopRate = 0
		sr_avgCoopNeighbour = 0
		sr_avgCoopNewcomer = 0
		sr_avgCoopStranger = 0
		sr_avgTrustRate = 0
		sr_avgTrustNeighbour = 0
		sr_avgTrustNewcomer = 0
		sr_avgTrustStranger = 0
		sr_avgChkTTSRate = 0
		sr_avgChkTTSNeighbour = 0
		sr_avgChkTTSNewcomer = 0
		sr_avgChkTTSStranger = 0
		sr_avgPayoffAll = 0
		sr_avgPayoffNeighbour = 0
		sr_avgPayoffNewcomer = 0
		sr_avgPayoffStranger = 0
		sr_avgMarketSize = 0
		sr_avgMeanPropCoop = 0
		sr_avgMeanPropMkt = 0
		sr_avgMeanPropChkTTS = 0
	END SUBROUTINE reset_sr_statistics
	
END MODULE
