!
!	mod_trust.f90
!	ReplicationMS
!
!	Created by Oliver Will on 04.06.09.
!	Copyright 2009 Universität Bayreuth. All rights reserved.
!
MODULE MOD_TRUST

	USE MOD_GLOBAL_VARIABLES
	USE MOD_AGENTSET
	
CONTAINS

	SUBROUTINE decide_on_trusting
	
		INTEGER :: i
		REAL :: rand
		
		
		DO i = 1, number_of_agents
			IF ( Partner(i) > 0 ) THEN
				CALL random_number(rand)
				IF ( rand < PropChkTTS(i) ) THEN
					! agent i checks telltale signs
					TTSChecked(i) = 1
					CALL random_number(rand)
					IF ( rand < PropCoop(Partner(i)) ) THEN
						Trusts(i) = 1
					ELSE
						Trusts(i) = 0
					END IF
				ELSE
					! agent i is parochial, i.e. trust neighbors she know and distrusts otherwise
					TTSChecked(i) = 0
					IF ( TempAddress(i) == 0 ) THEN
						! i is on the market an distrusts
						Trusts(i) = 0
					ELSE
						! i is in neighbourhood an trusts if partner is not a newcomer
						Trusts(i) = 1 - Newcomer(Partner(i))
					END IF
				END IF
			END IF
		END DO
		
	END SUBROUTINE decide_on_trusting

END MODULE
